# SPFN (Problem 3(c,d))

Implement the function "compute_parameters" and "compute_residue_loss" for cone, cylinder, plane and sphere in src/primitive.
For this assignment, you need to obtain a null_space matrix of 6xK, each column vector as one subspace where motion is slipable.

For "compute_parameters", the input contains
1. the point locations (BxNx3).
2. the weight matrix (BxNxK).
3. the point normals (BxNx3).
B is the batch size, N is the number of points, and K is the K-th primitive. You are required to return K parameters for each item of the batch. Specifically, parameters contain vectors (BxKx3) and scalars (BxK). Check the code to see what specifically you need to return.

For "compute_residue_loss", the input contains
1. parameters (corresponding to the result of compute_parameters).
2. ground truth point cloud (BxKxNx3), representing for each item of the batch K point clouds associated with K primitives.
3. matching_indices (BxK): y = matching_indices[b, x] means for the b-th item, the x-th ground truth instance corresponds to y-th parameter in "parameters".
For each ground truth point return the per-point squared distance (BxKxN) according to the parameters.

You should be able to run the following script to verify the correctness of your implementation.
```
sh test.sh
```