import tensorflow as tf
from math import pi as PI

class Cone:
    @staticmethod
    def get_primitive_name():
        return 'cone'

    @staticmethod
    def compute_parameters(feed_dict, parameters):
        P = feed_dict['P']  # B x N x 3
        W = feed_dict['W']  # B x N x K
        X = feed_dict['normal_per_point']  # B x N x 3

        batch_size = P.shape[0]
        num_points = W.shape[1]
        num_primitive = W.shape[2]

        # your implementation
        parameters['cone_apex'] = tf.zeros(dtype=tf.float32, shape=[batch_size,num_primitive,3])  # B x K x 3
        parameters['cone_axis'] = tf.zeros(dtype=tf.float32, shape=[batch_size,num_primitive,3])  # B x K x 3
        parameters['cone_half_angle'] = tf.zeros(dtype=tf.float32, shape=[batch_size,num_primitive])  # B x K

    @staticmethod
    def compute_residue_loss(parameters, P_gt, matching_indices):
        batch_size = P_gt.shape[0]
        num_points = P_gt.shape[2]
        num_primitive = matching_indices.shape[1]

        # your implementation
        return tf.zeros(dtype=tf.float32, shape=[batch_size, num_primitive, num_points])


    def __init__(self, apex, axis, half_angle, z_min=0.0, z_max=10.0):
        self.apex = apex
        self.axis = axis
        self.half_angle = half_angle
        self.z_min = z_min
        self.z_max = z_max
    