import tensorflow as tf

class Cylinder:
    @staticmethod
    def get_primitive_name():
        return 'cylinder'

    @staticmethod
    def compute_parameters(feed_dict, parameters):
        P = feed_dict['P']  # B x N x 3
        W = feed_dict['W']  # B x N x K
        X = feed_dict['normal_per_point']  # B x N x K

        batch_size = P.shape[0]
        num_points = W.shape[1]
        num_primitive = W.shape[2]

        # your implementation
        parameters['cylinder_axis'] = tf.zeros(dtype=tf.float32, shape=[batch_size,num_primitive,3]) # B x K x 3
        parameters['cylinder_center'] = tf.zeros(dtype=tf.float32, shape=[batch_size,num_primitive,3]) # B x K x 3
        parameters['cylinder_radius_squared'] = tf.zeros(dtype=tf.float32, shape=[batch_size,num_primitive])# B x K

    @staticmethod
    def compute_residue_loss(parameters, P_gt, matching_indices):
        batch_size = P_gt.shape[0]
        num_points = P_gt.shape[2]
        num_primitive = matching_indices.shape[1]

        # your implementation
        return tf.zeros(dtype=tf.float32, shape=[batch_size, num_primitive, num_points])


    def __init__(self, center, radius, axis, height=10.0):
        self.center = center
        self.radius = radius
        self.axis = axis
        self.height = height

        tmp_axis = make_rand_unit_vector()
        self.x_axis = normalized(np.cross(tmp_axis, self.axis))
        self.y_axis = normalized(np.cross(self.axis, self.x_axis))

